from typing import Any

from sqlalchemy.ext.declarative import declared_attr
from sqlalchemy.orm import as_declarative


@as_declarative()
class Base:
    id: Any
    __name__: str

    # Generate tablename automatically based on class name
    @declared_attr
    def __tablename__(self) -> str:
        return self.__name__.lower()
